// inlets and outlets
inlets = 1;
outlets = 2;

// global variables and arrays
var numinput = 0;
var maxinput = 10;
var seqcounter = 0;
var thereverse = 0;
var values = [];
var count = 0;

// Maxobj variables for scripting
var controlin = new Array(128);
var theinputs = new Array(128);
var thefunnel;

// methods start here

// inputs -- generates and binds the inputs in the max patch
function input(val)
{

	if(arguments.length) // bail if no arguments
	{
		// parse arguments
		var a = arguments[0];
		count = 0;
		// safety check for number of inputs
		if(a<0) a = 0; // too few inputs, set to 0
		if(a>maxinput) a = 128; // too many inputs, set to 128

		// out with the old...
		if(numinput) this.patcher.remove(thefunnel); // if we've done this before, get rid of the funnel
		for(var i=0;i<numinput;i++) // get rid of the input objects using the old number of inputs
		{
			values[i] = 0;
			this.patcher.remove(controlin[i]);
			this.patcher.remove(theinputs[i]);
		}

		// ...in with the new
		numinput = a; // update our global number of inputs to the new value
		outlet(0,numinput);
		if(numinput) thefunnel = this.patcher.newdefault(300, 300, "funnel", a); // make the funnel
		for(var k=0;k<a;k++) // create the new input objects, connect them to the funnel
		{
			theinputs[k] = this.patcher.newdefault(300+(k*100), 100, "inlet");
			this.patcher.connect(theinputs[k], 0, thefunnel, k);
		}

		// connect new objects to this js object's inlet
		ourself = this.box; // assign a Maxobj to our js object
		if (numinput) this.patcher.connect(thefunnel, 0, ourself, 0); // connect the funnel to us
	}

	else // complain about arguments
	{
		post("input message needs arguments");
		post();
	}
}

function bang(){
	count++;
	var s = "" + count;
	for(var i = 0; i < values.length; i++){
		s += " " + values[i];
	}
	outlet(1,s);
}

function list(i,x){
	values[i] = x;
}